#pragma semicolon 1

#include <sourcemod>
#include <sdktools_functions>
#include <adminmenu>

public Plugin:myinfo = 
{
	name	= "Knife Bot Detector",
	author	= "wS (World-Source.Ru)",
	version = "1.1"
};

public OnPluginStart()
{
	RegAdminCmd("sm_kb", sm_kb, ADMFLAG_GENERIC);
}

public Action:sm_kb(admin, args)
{
	wS_ShowPlayers(admin);
	return Plugin_Handled;
}

stock wS_ShowPlayers(admin, item = 0)
{
	new Handle:menu = CreateMenu(menu_CallBack);
	SetMenuTitle(menu, "Проверить на КБ:\n \n");
	SetMenuExitBackButton(menu, true);
	decl String:str_id[15], String:str_nick[32];
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && !IsFakeClient(i))
		{
			IntToString(GetClientUserId(i), str_id, 15);
			str_nick[0] = '\0';
			GetClientName(i, str_nick, 32);
			AddMenuItem(menu, str_id, str_nick, i != admin ? ITEMDRAW_DEFAULT : ITEMDRAW_DISABLED);
		}
	}
	DisplayMenuAtItem(menu, admin, item, 0);
}

new Handle:g_hTimer[MAXPLAYERS + 1] = {INVALID_HANDLE, ...};
new Float:g_fMyOldPos[MAXPLAYERS + 1][3];

public menu_CallBack(Handle:menu, MenuAction:action, admin, item)
{
	if (action == MenuAction_End)
		CloseHandle(menu);

	else if (action == MenuAction_Cancel && item == MenuCancel_ExitBack)
	{
		new Handle:hAdminMenu = GetAdminTopMenu();
		if (hAdminMenu != INVALID_HANDLE) DisplayTopMenu(hAdminMenu, admin, TopMenuPosition_LastCategory);
	}

	else if (action == MenuAction_Select)
	{
		if (g_hTimer[admin] == INVALID_HANDLE)
		{
			decl String:str_id[15];
			if (!GetMenuItem(menu, item, str_id, 15))
				return;

			new target = GetClientOfUserId(StringToInt(str_id));
			if (target > 0 && IsPlayerAlive(admin) && IsPlayerAlive(target))
			{
				SetEntProp(admin,  Prop_Data, "m_CollisionGroup", 2);
				SetEntProp(target, Prop_Data, "m_CollisionGroup", 2);
				wS_SetColor(admin, 255, 255, 255, 0);
				decl Float:pos[3];
				GetClientAbsOrigin(target, pos);
				GetClientAbsOrigin(admin, g_fMyOldPos[admin]);
				TeleportEntity(admin, pos, NULL_VECTOR, NULL_VECTOR);
				g_hTimer[admin] = CreateTimer(0.02, g_hTimer_CallBack, admin);
			}
			else
				PrintCenterText(admin, "Вы и цель должны быть живы");
		}
		wS_ShowPlayers(admin, GetMenuSelectionPosition());
	}
}

public Action:g_hTimer_CallBack(Handle:timer, any:admin)
{
	g_hTimer[admin] = INVALID_HANDLE;
	if (IsClientInGame(admin))
	{
		wS_SetColor(admin, 255, 255, 255, 255);
		if (IsPlayerAlive(admin))
		{
			PrintCenterText(admin, "КБ не обнаружен");
			TeleportEntity(admin, g_fMyOldPos[admin], NULL_VECTOR, NULL_VECTOR);
		}
		else
			PrintCenterText(admin, "КБ!");
	}
	return Plugin_Stop;
}

stock wS_SetColor(entity, r, g, b, a)
{
	SetEntityRenderMode(entity, RENDER_TRANSCOLOR);
	SetEntityRenderColor(entity, r, g, b, a);
}